#SingleInstance, Force
SendMode Input
SetBatchLines, -1
SetWorkingDir, %A_ScriptDir%
#NoTrayIcon

;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
                                                                                                                                ;;Variables
gdPath :=
getSetValue :=
getPathValue :=
getImgValue1 :=
getImgValue2 :=
getImgValue3 :=
defaultStmPath := A_ProgramFiles " (x86)\Steam\steamapps\common\Grim Dawn"
defaultGOGPath := A_ProgramFiles " (x86)\GOG Galaxy\Games\Grim Dawn"
loadscreenSwitcherPath := A_MyDocuments "\My Games\_gdswitcher\load_screens"
loadscreenSwitcherIniPath := loadscreenSwitcherPath "\loadscreen_switcher.ini"
gdLocalSaveFolderPath := A_MyDocuments "\My Games\Grim Dawn"
loadingPath := gdLocalSaveFolderPath "\Settings\UI\loading"
loading1 := loadingPath "\loadingbackground01.tex"
loading2 := loadingPath "\loadingbackground02.tex"
loading3 := loadingPath "\loadingbackground03.tex"

;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
                                                                                                                                ;;Initial Actions/Checks
SetWorkingDir, %loadscreenSwitcherPath%

If FileExist(loadscreenSwitcherIniPath) {

    IniRead, getSetValue, %loadscreenSwitcherIniPath%, Set Steam or GOG, Set
    IniRead, getPathValue, %loadscreenSwitcherIniPath%, GD Path, Path
    IniRead, getImgValue1, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground01
    IniRead, getImgValue2, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground02
    IniRead, getImgValue3, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground03

} Else {

    FileCreateDir, %loadscreenSwitcherPath%
    FileCreateDir, %loadingPath%
    IniWrite, Null, %loadscreenSwitcherIniPath%, Set Steam or GOG, Set
    IniWrite, Null, %loadscreenSwitcherIniPath%, GD Path, Path
    IniWrite, Null, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground01
    IniWrite, Null, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground02
    IniWrite, Null, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground03
    IniRead, getSetValue, %loadscreenSwitcherIniPath%, Set Steam or GOG, Set
    IniRead, getPathValue, %loadscreenSwitcherIniPath%, GD Path, Path
    IniRead, getImgValue1, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground01
    IniRead, getImgValue2, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground02
    IniRead, getImgValue3, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground03
}

IniRead, checkVal1, %loadscreenSwitcherIniPath%, List Values, Loading
If (checkVal1 == "ERROR") {

    IniWrite, loadingbackground01, %loadscreenSwitcherIniPath%, List Values, Loading
    IniWrite, Null, %loadscreenSwitcherIniPath%, List Values, Images
}

IniRead, checkVal1, %loadscreenSwitcherIniPath%, Timer, Unit
If (checkVal1 == "ERROR") {

    IniWrite, mins, %loadscreenSwitcherIniPath%, Timer, Unit
    IniWrite, 4, %loadscreenSwitcherIniPath%, Timer, mins
    IniWrite, 30, %loadscreenSwitcherIniPath%, Timer, secs
}


If (getSetValue == "Steam") || (getSetValue == "GOG") {

    gdPath := getPathValue

} Else If FileExist(defaultStmPath "\Grim Dawn.exe") && FileExist(defaultGOGPath "\Grim Dawn.exe") {

    MsgBox, 4, Choose Steam or GOG, Both Steam and GOG copies of Grim Dawn are detected.`n`nPress Yes to use the Steam copy.`nPress No to use the GOG copy.`n`nPress Ctrl+Alt+W to change this in the future.
    IfMsgBox Yes
    {
        gdPath := defaultStmPath
        IniWrite, Steam, %loadscreenSwitcherIniPath%, Set Steam or GOG, Set
        IniWrite, %gdPath%, %loadscreenSwitcherIniPath%, GD Path, Path
        IniRead, getSetValue, %loadscreenSwitcherIniPath%, Set Steam or GOG, Set
        IniRead, getPathValue, %loadscreenSwitcherIniPath%, GD Path, Path

    } Else IfMsgBox No
    {
        gdPath := defaultGOGPath
        IniWrite, GOG, %loadscreenSwitcherIniPath%, Set Steam or GOG, Set
        IniWrite, %gdPath%, %loadscreenSwitcherIniPath%, GD Path, Path
        IniRead, getSetValue, %loadscreenSwitcherIniPath%, Set Steam or GOG, Set
        IniRead, getPathValue, %loadscreenSwitcherIniPath%, GD Path, Path
    }
} Else If FileExist(defaultStmPath "\Grim Dawn.exe") || FileExist(defaultGOGPath "\Grim Dawn.exe") {
    If FileExist(defaultStmPath "\Grim Dawn.exe") {

        gdPath := defaultStmPath
        IniWrite, Steam, %loadscreenSwitcherIniPath%, Set Steam or GOG, Set
        IniWrite, %gdPath%, %loadscreenSwitcherIniPath%, GD Path, Path
        IniRead, getSetValue, %loadscreenSwitcherIniPath%, Set Steam or GOG, Set
        IniRead, getPathValue, %loadscreenSwitcherIniPath%, GD Path, Path

    } Else If FileExist(defaultGOGPath "\Grim Dawn.exe") {

        gdPath := defaultGOGPath
        IniWrite, GOG, %loadscreenSwitcherIniPath%, Set Steam or GOG, Set
        IniWrite, %gdPath%, %loadscreenSwitcherIniPath%, GD Path, Path
        IniRead, getSetValue, %loadscreenSwitcherIniPath%, Set Steam or GOG, Set
        IniRead, getPathValue, %loadscreenSwitcherIniPath%, GD Path, Path
    }
} Else If FileExist(loadscreenSwitcherIniPath) && (getPathValue != "Null") {
    
    IniRead, pathValue, %loadscreenSwitcherIniPath%, GD Path, Path
    gdPath := pathValue

} Else {
    
    FileSelectFolder, getGDPath, , , Select the folder that contains the 'Grim Dawn.exe'`n`nPress Alt+Esc to exit program
    If ErrorLevel {

        Reload
        Gosub, GuiClose

    } Else If FileExist(getGDPath "\Grim Dawn.exe") {

        gdPath := getGDPath
        IniWrite, Null, %loadscreenSwitcherIniPath%, Set Steam or GOG, Set
        IniWrite, %getGDPath%, %loadscreenSwitcherIniPath%, GD Path, Path
        IniRead, getSetValue, %loadscreenSwitcherIniPath%, Set Steam or GOG, Set
        IniRead, getPathValue, %loadscreenSwitcherIniPath%, GD Path, Path
        MsgBox, , FYI, You can reset this path in the future by pressing:`nCtrl+Shift+W

    } Else {

        Reload
        Gosub, GuiClose
    }
}


If (getSetValue == "Null") {

    gdPath := getPathValue
}


texCompGDPath := gdPath "\TextureCompiler.exe"
texViewGDPath := gdPath "\TexViewer.exe"
freeImgGDPath := gdPath "\freeimage.dll"
DevILGDPath := gdPath "\DevIL.dll"
texCompSwtchPath := loadscreenSwitcherPath "\TextureCompiler.exe"
texViewSwtchPath := loadscreenSwitcherPath "\TexViewer.exe"
freeImgSwtchPath := loadscreenSwitcherPath "\freeimage.dll"
DevILSwtchPath := loadscreenSwitcherPath "\DevIL.dll"

If !FileExist(texCompSwtchPath) {
    If FileExist(texCompGDPath) {

        FileCopy, %texCompGDPath%, %texCompSwtchPath%
    }
}

If !FileExist(texViewSwtchPath) {
    If FileExist(texViewGDPath) {

        FileCopy, %texViewGDPath%, %texViewSwtchPath%
    }
}

If !FileExist(freeImgSwtchPath) {
    If FileExist(freeImgGDPath) {

        FileCopy, %freeImgGDPath%, %freeImgSwtchPath%
    }
}

If !FileExist(DevILSwtchPath) {
    If FileExist(DevILGDPath) {

        FileCopy, %DevILGDPath%, %DevILSwtchPath%
    }
}

IniRead, getImgValue1, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground01
IniRead, getImgValue2, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground02
IniRead, getImgValue3, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground03
Gosub, IntialLoadScreenCheck1
Gosub, IntialLoadScreenCheck2
Gosub, IntialLoadScreenCheck3

Settimer, TexCheck, 5000

;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
                                                                                                                                ;;Controls - Width,Height,X,Y coords
ProW1 := 730
ProH1 := 34
ProX1 := -10
ProY1 := 17

DdlW1 := 687
DdlH1 := 75
DdlX1 := 5
DdlY1 := 22

FolW1 := 10
FolH1 := 24
FolX1 := 695
FolY1 := 22

ProW2 := 730
ProH2 := 34
ProX2 := -10
ProY2 := 54

DdlW2 := 687
DdlH2 := 170
DdlX2 := 5
DdlY2 := 59

FolW2 := 10
FolH2 := 24
FolX2 := 695
FolY2 := 59

ProW3 := 730
ProH3 := 34
ProX3 := -10
ProY3 := 108

TxtW1 := 4
TxtH1 := 24
TxtX1 := 5
TxtY1 := 113

ChkW1 := 588
ChkH1 := 24
ChkX1 := 9
ChkY1 := 113

EdiW1 := 47
EdiH1 := 24
EdiX1 := 600
EdiY1 := 113

UpDW1 := 35
UpDH1 := 24
UpDX1 := 600
UpDY1 := 113

DdlW3 := 55 ;----------Mins/Secs
DdlH3 := 75
DdlX3 := 650
DdlY3 := 113

ProW4 := 360
ProH4 := 34
ProX4 := -10
ProY4 := 152

BtnW1 := 350
BtnH1 := 24
BtnX1 := -5
BtnY1 := 157

ProW5 := 360
ProH5 := 34
ProX5 := 360
ProY5 := 152

BtnW2 := 350
BtnH2 := 24
BtnX2 := 365
BtnY2 := 157

ProW6 := 730
ProH6 := 74
ProX6 := -10
ProY6 := 201

TxtW2 := 720
TxtH2 := 18
TxtX2 := -5
TxtY2 := 206

TxtW3 := 720
TxtH3 := 18
TxtX3 := -5
TxtY3 := 229

TxtW4 := 720
TxtH4 := 18
TxtX4 := -5
TxtY4 := 252

GuiW := 710
GuiH := 275

;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
                                                                                                                                ;;Controls - Add
Gui, +HwndHGUI
Gui, Color, 3C3C3C



Gui, Add, Progress, Disabled w%ProW1% h%ProH1% x%ProX1% y%ProY1% Background262626

Gui, Font, s10, Verdana
Gui, Add, DropDownList, vLoadScreens gOnSelect1 w%DdlW1% h%DdlH1% x%DdlX1% y%DdlY1%, loadingbackground01||loadingbackground02|loadingbackground03

IniRead, getLoadingVal, %loadscreenSwitcherIniPath%, List Values, Loading
GuiControl, ChooseString, ComboBox1, %getLoadingVal%
Gosub, OnSelect1

Gui, Font, s11, Verdana
Gui, Add, Button, vOpnFold1 gOpenFolder1 w%FolW1% h%FolH1% x%FolX1% y%FolY1%



Loop %loadscreenSwitcherPath%\*.jpg
{
    ImgList = %ImgList%%A_LoopFileName%|

} Loop %loadscreenSwitcherPath%\*.png
{
    ImgList = %ImgList%%A_LoopFileName%|
    
} Loop %loadscreenSwitcherPath%\*.bmp
{
    ImgList = %ImgList%%A_LoopFileName%|

} Loop %loadscreenSwitcherPath%\*.tga
{
    ImgList = %ImgList%%A_LoopFileName%|

} Loop %loadscreenSwitcherPath%\*.psd
{
    ImgList = %ImgList%%A_LoopFileName%|

} Loop %loadscreenSwitcherPath%\*.ico
{
    ImgList = %ImgList%%A_LoopFileName%|
}

ImgList := RTrim(ImgList, "|")

FoundPos := InStr(ImgList, "|")
If (FoundPos == 0) {
    ImgList := ImgList "|"
}

ImgList2 := StrReplace(ImgList, "|", "||",, 1) ; make first item default

Gui, Add, Progress, Disabled w%ProW2% h%ProH2% x%ProX2% y%ProY2% Background262626

Gui, Font, s10, Verdana
Gui, Add, DropDownList, vSelectedImg gOnSelect2 w%DdlW2% h%DdlH2% x%DdlX2% y%DdlY2%, % ImgList2

IniRead, getImagesVal, %loadscreenSwitcherIniPath%, List Values, Images
GuiControl, ChooseString, ComboBox2, %getImagesVal%
Gosub, OnSelect2

Gui, Font, s11, Verdana
Gui, Add, Button, vOpnFold2 gOpenFolder2 w%FolW2% h%FolH2% x%FolX2% y%FolY2%



Gui, Add, Progress, Disabled w%ProW3% h%ProH3% x%ProX3% y%ProY3% Background262626

Gui, Font, s11, Verdana
Gui, Add, Text, w%TxtW1% h%TxtH1% x%TxtX1% y%TxtY1%

StrReplace(ImgList, "|", "+", Count2)
If (Count2 == 1) {

    ImgList3 := RTrim(ImgList, "|")

} Else {

    ImgList3 := ImgList
}

ImgListArr := StrSplit(ImgList3, "|")

Count := 0
for key, value in ImgListArr
{
    Count++
}

IniRead, getUnitVal, %loadscreenSwitcherIniPath%, Timer, Unit
IniRead, getminsVal, %loadscreenSwitcherIniPath%, Timer, mins
IniRead, getsecsVal, %loadscreenSwitcherIniPath%, Timer, secs
If (getUnitVal == "mins") {

    chkbox_time := "Minutes"
    chkbox_num = %getminsVal%
    upd_range := "Range1-30"
    upd_range_start = %getminsVal%

} Else If (getUnitVal == "secs") {

    chkbox_time := "Seconds"
    chkbox_num = %getsecsVal%
    upd_range := "Range10-59"
    upd_range_start = %getsecsVal%

} chkbox_text := "              Randomize Every"

Gui, Font, s11, Verdana
Gui, Add, CheckBox, Center 0x1 vRandOnOff gRandOnOffCheck w%ChkW1% h%ChkH1% x%ChkX1% y%ChkY1% cc1c2b0, %chkbox_text% %chkbox_num% %chkbox_time% ;------Checkbox

Gui, Font, s11, Verdana
Gui, Add, Edit, 0x801 vEdiUpd w%EdiW1% h%EdiH1% x%EdiX1% y%EdiY1% cc1c2b0
Gui, Add, UpDown, vMyUpDown gOnSelect3 %upd_range%, %upd_range_start%

Gui, Font, s10, Verdana
Gui, Add, DropDownList, vMinsSecs gOnSelect4 w%DdlW3% h%DdlH3% x%DdlX3% y%DdlY3%, mins||secs


If (getUnitVal == "secs") {

    GuiControl, ChooseString, ComboBox3, secs
}

Gosub, OnSelect3
Gosub, OnSelect4



Gui, Add, Progress, Disabled w%ProW4% h%ProH4% x%ProX4% y%ProY4% Background262626

btnText1 := "Set  "
Gui, Font, s11, Verdana
Gui, Add, Button, Right vSetBtn gPushSetBtn w%BtnW1% h%BtnH1% x%BtnX1% y%BtnY1%, %btnText1% ;------Set Button

Gui, Add, Progress, Disabled w%ProW5% h%ProH5% x%ProX5% y%ProY5% Background262626

btnText2 := "  Reset"
Gui, Font, s11, Verdana
Gui, Add, Button, Left vResetBtn gPushResetBtn w%BtnW2% h%BtnH2% x%BtnX2% y%BtnY2%, %btnText2% ;------Reset Button

IniRead, getImgValue1, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground01
If (getImgValue1 == "Null") {

    displayImg1 := "Please 'Set' a custom image for "

} Else {

    displayImg1 := getImgValue1 " is active for"

}



Gui, Add, Progress, Disabled w%ProW6% h%ProH6% x%ProX6% y%ProY6% Background262626

Gui, Font, s10, Verdana
Gui, Add, Text, Right vTxt1 gOpenImage1 cc1c2b0 w%TxtW2% h%TxtH2% x%TxtX2% y%TxtY2%, %displayImg1% - loadingbackground01 - '

IniRead, getImgValue2, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground02
If (getImgValue2 == "Null") {

    displayImg2 := "Please 'Set' a custom image for "

} Else {

    displayImg2 := getImgValue2 " is active for"
}

Gui, Font, s10, Verdana
Gui, Add, Text, Right vTxt2 gOpenImage2 cc1c2b0 w%TxtW3% h%TxtH3% x%TxtX3% y%TxtY3%, %displayImg2% - loadingbackground02 - '

IniRead, getImgValue3, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground03
If (getImgValue3 == "Null") {

    displayImg3 := "Please 'Set' a custom image for "

} Else {

    displayImg3 := getImgValue3 " is active for"
}

Gui, Font, s10, Verdana
Gui, Add, Text, hwndHBTNA Right vTxt3 gOpenImage3 cc1c2b0 w%TxtW4% h%TxtH4% x%TxtX4% y%TxtY4%, %displayImg3% - loadingbackground03 - '



Gui, Show, w%GuiW% h%GuiH%, Loadscreen Switcher
Return

;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
                                                                                                                                ;;Functions
PushBtnSetFocus(HGUI, HBTN) { ; WM_NEXTDLGCTL = 0x0028
   SendMessage, 0x0028, HBTN, 1, , ahk_id %HGUI%
}

GuiClose:
ExitApp
Return
!Esc::
ExitApp
Return



IntialLoadScreenCheck1:
If (getImgValue1 != "Null") {

    RunWait, powershell.exe -Command ./TextureCompiler.exe ./%getImgValue1% -nopoweroftwo \"%loading1%\",, hide
    Sleep, 200
    Process, Close, powershell.exe

} Return

IntialLoadScreenCheck2:
If (getImgValue2 != "Null") {

    RunWait, powershell.exe -Command ./TextureCompiler.exe ./%getImgValue2% -nopoweroftwo \"%loading2%\",, hide
    Sleep, 200
    Process, Close, powershell.exe
    
} Return

IntialLoadScreenCheck3:
If (getImgValue3 != "Null") {

    RunWait, powershell.exe -Command ./TextureCompiler.exe ./%getImgValue3% -nopoweroftwo \"%loading3%\",, hide
    Sleep, 200
    Process, Close, powershell.exe
    
} Return



OnSelect1:
Gui, Submit, nohide
PushBtnSetFocus(HGUI, HBTNA)
IniWrite, %LoadScreens%, %loadscreenSwitcherIniPath%, List Values, Loading
Return

OnSelect2:
Gui, Submit, nohide
PushBtnSetFocus(HGUI, HBTNA)
IniWrite, %SelectedImg%, %loadscreenSwitcherIniPath%, List Values, Images
Return

OnSelect3:
Gui, Submit, nohide
PushBtnSetFocus(HGUI, HBTNA)
GuiControl,,RandOnOff, %chkbox_text% %MyUpDown% %chkbox_time%
If (MinsSecs == "mins") {

    IniWrite, %MyUpDown%, %loadscreenSwitcherIniPath%, Timer, mins

} Else If (MinsSecs == "secs") {

    IniWrite, %MyUpDown%, %loadscreenSwitcherIniPath%, Timer, secs

} Return

OnSelect4:
Gui, Submit, nohide
PushBtnSetFocus(HGUI, HBTNA)
If (MinsSecs == "mins") {

    IniRead, getmins, %loadscreenSwitcherIniPath%, Timer, mins
    upd_range := "Range1-30"
    upd_range_start = %getmins%
    GuiControl, +%upd_range%, MyUpDown
    GuiControl,, MyUpDown, %upd_range_start%
    Gosub, OnSelect3
    chkbox_time := "Minutes"
    GuiControl,,RandOnOff, %chkbox_text% %MyUpDown% %chkbox_time%
    IniWrite, mins, %loadscreenSwitcherIniPath%, Timer, Unit
    IniWrite, %MyUpDown%, %loadscreenSwitcherIniPath%, Timer, mins

} Else If (MinsSecs == "secs") {

    IniRead, getsecs, %loadscreenSwitcherIniPath%, Timer, secs
    upd_range := "Range10-59"
    upd_range_start = %getsecs%
    GuiControl, +%upd_range%, MyUpDown
    GuiControl,, MyUpDown, %upd_range_start%
    Gosub, OnSelect3
    chkbox_time := "Seconds"
    GuiControl,,RandOnOff, %chkbox_text% %MyUpDown% %chkbox_time%
    IniWrite, secs, %loadscreenSwitcherIniPath%, Timer, Unit
    IniWrite, %MyUpDown%, %loadscreenSwitcherIniPath%, Timer, secs

} Return



OpenFolder1:
PushBtnSetFocus(HGUI, HBTNA)
Run, %loadingPath%
Return

OpenFolder2:
PushBtnSetFocus(HGUI, HBTNA)
Run, %loadscreenSwitcherPath%
Return



RandOnOffCheck:
PushBtnSetFocus(HGUI, HBTNA)
If (Count == 1) || (Count == 2) || (Count == 3) {

    MsgBox, , Warning, Need at least 4+ images available to use this feature!
    GuiControl,, RandOnOff, 0

} Else {

    ControlGet, isitchecked, Checked , , Button3, Loadscreen Switcher
    If (isitchecked == "1") {

        GuiControl, Disable, ComboBox1
        GuiControl, Disable, ComboBox2
        GuiControl, Disable, Button4
        GuiControl, Disable, Button5
        GuiControl, Disable, Edit1
        GuiControl, Disable, ComboBox3

        If (MinsSecs == "mins") {

            myTime := (60000 * MyUpDown)
            Settimer, Instructions, %myTime%

        } Else If (MinsSecs == "secs") {

            myTime := (1000 * MyUpDown)
            Settimer, Instructions, %myTime%
            
        } Gosub, Instructions

    } Else If (isitchecked == "0") {

        GuiControl, Enable, ComboBox1
        GuiControl, Enable, ComboBox2
        GuiControl, Enable, Button4
        GuiControl, Enable, Button5
        GuiControl, Enable, Edit1
        GuiControl, Enable, ComboBox3

        Settimer, Instructions, Off
    }
} Return

Instructions:
Random, OutputVar1, 1, Count
OutputVar1 := ImgListArr[OutputVar1]
RunWait, powershell.exe -Command ./TextureCompiler.exe ./%OutputVar1% -nopoweroftwo \"%loading1%\",, hide
Sleep, 200
Process, Close, powershell.exe
GuiControl,,Txt1, %OutputVar1% is active for - loadingbackground01 - '
IniWrite, %OutputVar1%, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground01
IniRead, getImgValue1, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground01

Random, OutputVar2, 1, Count
OutputVar2 := ImgListArr[OutputVar2]
RunWait, powershell.exe -Command ./TextureCompiler.exe ./%OutputVar2% -nopoweroftwo \"%loading2%\",, hide
Sleep, 200
Process, Close, powershell.exe
GuiControl,,Txt2, %OutputVar2% is active for - loadingbackground02 - '
IniWrite, %OutputVar2%, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground02
IniRead, getImgValue2, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground02

Random, OutputVar3, 1, Count
OutputVar3 := ImgListArr[OutputVar3]
RunWait, powershell.exe -Command ./TextureCompiler.exe ./%OutputVar3% -nopoweroftwo \"%loading3%\",, hide
Sleep, 200
Process, Close, powershell.exe
GuiControl,,Txt3, %OutputVar3% is active for - loadingbackground03 - '
IniWrite, %OutputVar3%, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground03
IniRead, getImgValue3, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground03
Return



TexCheck:
IniRead, getImgValue1, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground01
IniRead, getImgValue2, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground02
IniRead, getImgValue3, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground03

If !FileExist(loading1) && (getImgValue1 != "Null") {

    Gosub, IntialLoadScreenCheck1
}

If !FileExist(loading2) && (getImgValue2 != "Null") {

    Gosub, IntialLoadScreenCheck2
}

If !FileExist(loading3) && (getImgValue3 != "Null") {

    Gosub, IntialLoadScreenCheck3
    
} Return



PushSetBtn:
PushBtnSetFocus(HGUI, HBTNA)
If (Loadscreens == "loadingbackground01") {

    RunWait, powershell.exe -Command ./TextureCompiler.exe ./%SelectedImg% -nopoweroftwo \"%loading1%\",, hide
    Sleep, 200
    Process, Close, powershell.exe
    GuiControl,,Txt1, %SelectedImg% is active for - loadingbackground01 - '
    IniWrite, %SelectedImg%, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground01
    IniRead, getImgValue1, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground01

} Else If (Loadscreens == "loadingbackground02") {

    RunWait, powershell.exe -Command ./TextureCompiler.exe ./%SelectedImg% -nopoweroftwo \"%loading2%\",, hide
    Sleep, 200
    Process, Close, powershell.exe
    GuiControl,,Txt2, %SelectedImg% is active for - loadingbackground02 - '
    IniWrite, %SelectedImg%, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground02
    IniRead, getImgValue2, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground02

} Else If (Loadscreens == "loadingbackground03") {

    RunWait, powershell.exe -Command ./TextureCompiler.exe ./%SelectedImg% -nopoweroftwo \"%loading3%\",, hide
    Sleep, 200
    Process, Close, powershell.exe
    GuiControl,,Txt3, %SelectedImg% is active for - loadingbackground03 - '
    IniWrite, %SelectedImg%, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground03
    IniRead, getImgValue3, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground03

} Return

PushResetBtn:
PushBtnSetFocus(HGUI, HBTNA)

FileDelete, %loading1%
GuiControl,,Txt1, Please 'Set' a custom image for - loadingbackground01 - '
IniWrite, Null, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground01
IniRead, getImgValue1, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground01

FileDelete, %loading2%
GuiControl,,Txt2, Please 'Set' a custom image for - loadingbackground02 - '
IniWrite, Null, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground02
IniRead, getImgValue2, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground02

FileDelete, %loading3%
GuiControl,,Txt3, Please 'Set' a custom image for - loadingbackground03 - '
IniWrite, Null, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground03
IniRead, getImgValue3, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground03
Return



OpenImage1:
IniRead, getImgValue1, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground01
If (getImgValue1 == "Null") {

    ; kick rocks

} Else {
    
    try  ; Attempts to execute code.
    {
        Run %loadscreenSwitcherPath%\%getImgValue1%, Max UseErrorLevel
    }
    catch e  ; Handles the first error/exception raised by the block above.
    {
        MsgBox, The listed image:`n'%getImgValue1%'`n`n..no longer appears to be present in:`n%loadscreenSwitcherPath%
        Exit
    }
} Return

OpenImage2:
IniRead, getImgValue2, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground02
If (getImgValue2 == "Null") {

    ; kick rocks

} Else {
    
    try  ; Attempts to execute code.
    {
        Run %loadscreenSwitcherPath%\%getImgValue2%, Max UseErrorLevel
    }
    catch e  ; Handles the first error/exception raised by the block above.
    {
        MsgBox, The listed image:`n'%getImgValue1%'`n`n..no longer appears to be present in:`n%loadscreenSwitcherPath%
        Exit
    }
} Return

OpenImage3:
IniRead, getImgValue3, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground03
If (getImgValue3 == "Null") {

    ; kick rocks

} Else {
    
    try  ; Attempts to execute code.
    {
        Run %loadscreenSwitcherPath%\%getImgValue3%, Max UseErrorLevel
    }
    catch e  ; Handles the first error/exception raised by the block above.
    {
        MsgBox, The listed image:`n'%getImgValue1%'`n`n..no longer appears to be present in:`n%loadscreenSwitcherPath%
        Exit
    }
} Return



;----------------------------------------------------------------------------



;----------------------------------------------------------------------------

^!w::
IniWrite, Null, %loadscreenSwitcherIniPath%, Set Steam or GOG, Set
Reload
Gosub, GuiClose
Return

^+!w::
IniWrite, Null, %loadscreenSwitcherIniPath%, GD Path, Path
IniWrite, Null, %loadscreenSwitcherIniPath%, Set Steam or GOG, Set
Reload
Gosub, GuiClose
Return

GuiContextMenu:
If (A_GuiControl == "Txt1") {
    
    IniRead, getImgValue1, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground01
    If (getImgValue1 == "Null") {

        ; kick rocks

    } Else {
        
        Run, %texViewSwtchPath% "%loading1%"
        Sleep 200
        Send {LWin Down}
        Send {Up}
        Send {LWin Up}
    }
} Else If (A_GuiControl == "Txt2") {

    IniRead, getImgValue2, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground02
    If (getImgValue2 == "Null") {

        ; kick rocks

    } Else {
        
        Run, %texViewSwtchPath% "%loading2%"
        Sleep 200
        Send {LWin Down}
        Send {Up}
        Send {LWin Up}
    }
} Else If (A_GuiControl == "Txt3") {

    IniRead, getImgValue3, %loadscreenSwitcherIniPath%, Active Loading Screens, loadingbackground03
    If (getImgValue3 == "Null") {

        ; kick rocks

    } Else {

        Run, %texViewSwtchPath% "%loading3%"
        Sleep 200
        Send {LWin Down}
        Send {Up}
        Send {LWin Up}
    }
} Return
